
Redmine - Patch #24283

Validate length of string fields

2016-11-07 11:48 - Felix Schäfer

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 3.2.5   

Description

Databases throw errors when trying to save data that doesn't fit in the allotted space in the field (MySQL used to not do that and just

silently drop the part that was over the length of the field, but does throw errors in strict mode), which cause Redmine to crash.

The coming patch adds length validations for most fields a user can directly write to and that is a string (i.e. ist a VARCHAR in

MySQL)

Associated revisions

Revision 15989 - 2016-11-19 12:13 - Jean-Philippe Lang

Add length validations for string fields (#24283).

Patch by Felix Schäfer.

Revision 15991 - 2016-11-19 14:24 - Jean-Philippe Lang

Wrong validation introduced in r15989 (#24283).

Revision 16003 - 2016-11-26 10:04 - Jean-Philippe Lang

Merged r15989 and r15991 (#24283).

Revision 16004 - 2016-11-26 10:04 - Jean-Philippe Lang

Merged r15989 and r15991 (#24283).

Revision 16134 - 2017-01-04 21:55 - Jean-Philippe Lang

Validate length of custom field regexp (#24283).

Patch by Go MAEDA.

Revision 16135 - 2017-01-04 21:56 - Jean-Philippe Lang

Merged r16134 (#24283).

Revision 16136 - 2017-01-04 21:56 - Jean-Philippe Lang

Merged r16134 (#24283).

History

#1 - 2016-11-07 11:49 - Felix Schäfer

- File 24283.patch added

#2 - 2016-11-09 13:49 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#3 - 2016-11-19 12:14 - Jean-Philippe Lang

- Category set to Code cleanup/refactoring

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next minor release to 3.2.5

2025-05-17 1/2



Committed, thanks.

#4 - 2016-11-26 10:04 - Jean-Philippe Lang

- Status changed from Resolved to Closed

#5 - 2016-12-25 14:47 - Yui Naruse

validates_length_of :regexp, maximum: 30

 custom_fields.regexp is varchar(255).

It must be maximum: 255.

#6 - 2016-12-25 15:55 - Go MAEDA

- Status changed from Closed to Reopened

Yui Naruse wrote:

validates_length_of :regexp, maximum: 30

 custom_fields.regexp is varchar(255).

It must be maximum: 255.

 Thank you for pointing it out.

Reopening this issue.

Index: app/models/custom_field.rb

===================================================================

--- app/models/custom_field.rb    (revision 16111)

+++ app/models/custom_field.rb    (working copy)

@@ -32,7 +32,7 @@

   validates_presence_of :name, :field_format

   validates_uniqueness_of :name, :scope => :type

   validates_length_of :name, :maximum => 30

-  validates_length_of :regexp, maximum: 30

+  validates_length_of :regexp, maximum: 255

   validates_inclusion_of :field_format, :in => Proc.new { Redmine::FieldFormat.available_formats }

   validate :validate_custom_field

   attr_protected :id

#7 - 2017-01-04 21:56 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Committed, thanks.

Files

24283.patch 3.54 KB 2016-11-07 Felix Schäfer
